///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define AuthenticationString "trIeSPiUhouDlUwRLe5hie2H5awRoupiaDi8zI0fo3Y7u6R703r7e6rLacrouChi"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool IsValidCompanyPassword(int Client)
{
    char Statement[255];
    sprintf(Statement, "SELECT CompanyDatabase FROM Companys WHERE CompanyName = '%s' AND CompanyPassword = '%s'", CI[Client].CompanyName, CI[Client].CompanyPassword);

    HSTMT StatementHandle = NULL;

    if(!CI[Client].DBClass.DBExecute(Statement, &StatementHandle))
    {
        ErrorMessage(NULL, "DBexecute: IsValidCompanyPassword Fail.\n"); // FIXME: Need to log this error
        return false;
    }

    SQLINTEGER outRowCount = 0;
    if(SQLRowCount(StatementHandle, &outRowCount) != SQL_SUCCESS)
    {
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        ErrorMessage(NULL, "SQLRowCount: IsValidCompanyPassword Error.\n"); // FIXME: Need to log this error
        return false;
    }

    if(outRowCount != 1)
        return false;

    if(!CI[Client].DBClass.DBFetch(StatementHandle))
    {
        ErrorMessage(NULL, "DBFetch error .\n"); // FIXME: Need to log this error
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        return false;
    }

    SQLINTEGER DataLength = 0;
    SQLCHAR SQLBuffer[25 + 1];

    if(!CI[Client].DBClass.DBGetData(StatementHandle, 1, SQL_C_CHAR, SQLBuffer, 25, &DataLength))
    {
        ErrorMessage(NULL, "DBGetData error .\n"); // FIXME: Need to log this error
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        return false;
    }

    if(DataLength == -1)
	{
	    CI[Client].DBClass.DBCloseCursor(StatementHandle);
		return false;
	}

    memcpy(CI[Client].CompanyDB, SQLBuffer, DataLength);

    CI[Client].DBClass.DBCloseCursor(StatementHandle);

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define CLIENTVER_ERROR      1
#define CLIENTVER_CURRENT    2
#define CLIENTVER_SUPPORTED  3
#define CLIENTVER_OUTDATED   4
#define CLIENTVER_AUTOUPDATE 5

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int IsValidClientVersion(int Client, char *UpdateHTTPURL)
{
    char Statement[255];
    sprintf(Statement, "SELECT Status, UpdateURL FROM ClientVersions WHERE Version = '%s'", CI[Client].ClientVersion);

    HSTMT StatementHandle = NULL;

    if(!CI[Client].DBClass.DBExecute(Statement, &StatementHandle))
    {
        ErrorMessage(NULL, "DBexecute: IsValidClientVersion Fail.\n"); // FIXME: Need to log this error
        return CLIENTVER_ERROR;
    }

    SQLINTEGER outRowCount = 0;
    if(SQLRowCount(StatementHandle, &outRowCount) != SQL_SUCCESS)
    {
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        ErrorMessage(NULL, "SQLRowCount: IsValidClientVersion Error.\n"); // FIXME: Need to log this error
        return CLIENTVER_ERROR;
    }

    if(outRowCount == 0)
    {
        ErrorMessage(NULL, "Unknown client version .\n"); // FIXME: Need to log this error
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        return CLIENTVER_ERROR;
    }

    if(!CI[Client].DBClass.DBFetch(StatementHandle))
    {
        ErrorMessage(NULL, "DBFetch error .\n"); // FIXME: Need to log this error
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        return CLIENTVER_ERROR;
    }

    SQLINTEGER DataLength = 0;
    SQLCHAR ClientVersion[25 + 1];

    if(!CI[Client].DBClass.DBGetData(StatementHandle, 1, SQL_C_CHAR, ClientVersion, 25, &DataLength))
    {
        ErrorMessage(NULL, "DBGetData Status error .\n"); // FIXME: Need to log this error
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        return CLIENTVER_ERROR;
    }
    ClientVersion[DataLength] = '\0';

    if(!CI[Client].DBClass.DBGetData(StatementHandle, 2, SQL_C_CHAR, UpdateHTTPURL, 1024, &DataLength))
    {
        ErrorMessage(NULL, "DBGetData UpdateURL error .\n"); // FIXME: Need to log this error
        CI[Client].DBClass.DBCloseCursor(StatementHandle);
        return CLIENTVER_ERROR;
    }
    UpdateHTTPURL[DataLength] = '\0';

    CI[Client].DBClass.DBCloseCursor(StatementHandle);

    if(strcmpi((char *)ClientVersion, "current") == 0){ // Current version
        return CLIENTVER_CURRENT;
    }
    else if(strcmpi((char *)ClientVersion, "supported") == 0){ // Old but supported
        return CLIENTVER_SUPPORTED;
    }
    else if(strcmpi((char *)ClientVersion, "outdated") == 0){ // Old and nolonger supported
        return CLIENTVER_OUTDATED;
    }
    else if(strcmpi((char *)ClientVersion, "autoupdate") == 0){ // Old and nolonger supported
        return CLIENTVER_AUTOUPDATE;
    }
    else{
        MessageBox(NULL, "Unknown version identifier.", (char *)ClientVersion, 0); // FIXME: Need to log this error
        return CLIENTVER_ERROR;
    }

    return CLIENTVER_ERROR;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int AuthProcessCommand(int Client, char *ReceivedData, int ReceivedSize)
{
    int FlagLength = 0;
    int FlaggedLength = 0;
    char FlaggedData[MaxReceiveSize + 1];
	char SendTemp[MaxReceiveSize + 1];

    char StatusTemp[255];
		
	if((FlagLength = CompareFlagedString(ReceivedData, "::Authentication:")))
    {
        sprintf(StatusTemp, "(%d) Auth Command: Authentication.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);

        if(ReceivedSize - FlagLength > MaxReceiveSize || ReceivedSize - FlagLength < 8)
        {
            SimpleServerSend(Client, "::Error:Fatal error accepting authentication.");
            return AUTH_CMD_DISCONNECT;
        }

    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        if( strcmp(AuthenticationString, FlaggedData) == 0)
        {
            CI[Client].Authenticated = true;
            sprintf(StatusTemp, "(%d) Auth: Authentication Success.", MyServer.ClientID[Client]);
            WriteLog(StatusTemp);
            SimpleServerSend(Client, "::ReqCompanyName");
    		return AUTH_CMD_OK;
        }

        sprintf(StatusTemp, "(%d) Auth: Authentication Failed.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);

        SimpleServerSend(Client, "::Error:Pre-connect authentication failed.");
        return AUTH_CMD_FAILED;
    }
    else if( strcmp(ReceivedData, "Request.Disconnect") == 0)
    {
        sprintf(StatusTemp, "(%d) Auth Command: Disconnect.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);
        return AUTH_CMD_DISCONNECT;
    }
    else if(CI[Client].Authenticated == false)
    {
        sprintf(StatusTemp, "(%d) Auth Command: Unauthorized command.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);
        return AUTH_CMD_FAILED;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::CompanyName:")))
    {
        sprintf(StatusTemp, "(%d) Auth Command: CompanyName.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);

        if(ReceivedSize - FlagLength > 64 || ReceivedSize - FlagLength < 1)
        {
            sprintf(StatusTemp, "(%d) Auth: Fatal error accepting CompanyName.", MyServer.ClientID[Client]);
            WriteLog(StatusTemp);

            SimpleServerSend(Client, "::Error:Fatal error accepting CompanyName.");
            return AUTH_CMD_DISCONNECT;
        }

    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        strcpy(CI[Client].CompanyName, FlaggedData);
        SimpleServerSend(Client, "::ReqCompanyPassword");

        sprintf(StatusTemp, "(%d) Auth: Company name: '%s'.", MyServer.ClientID[Client], CI[Client].CompanyName);
        WriteLog(StatusTemp);

        return AUTH_CMD_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::CompanyPassword:")))
    {
        sprintf(StatusTemp, "(%d) Auth Command: CompanyPassword.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);

        if(ReceivedSize - FlagLength > 64 || ReceivedSize - FlagLength < 1)
        {
            sprintf(StatusTemp, "(%d) Auth: Fatal error accepting CompanyPassword.", MyServer.ClientID[Client]);
            WriteLog(StatusTemp);

            SimpleServerSend(Client, "::Error:Fatal error accepting CompanyPassword.");
            return AUTH_CMD_DISCONNECT;
        }

    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        strcpy(CI[Client].CompanyPassword, FlaggedData);

        sprintf(StatusTemp, "(%d) Auth: Company password: '%s'.", MyServer.ClientID[Client], CI[Client].CompanyPassword);
        WriteLog(StatusTemp);

        if(IsValidCompanyPassword(Client))
        {
            SimpleServerSend(Client, "::ReqClientVersion");
            return AUTH_CMD_OK;
        }

        sprintf(StatusTemp, "(%d) Auth: Invalid company account.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);

        SimpleServerSend(Client, "::Error:Invalid company account.");
        return AUTH_CMD_FAILED;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::ClientVersion:")))
    {
        sprintf(StatusTemp, "(%d) Auth Command: ClientVersion.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);

        if(ReceivedSize - FlagLength > 64 || ReceivedSize - FlagLength < 1)
        {
            sprintf(StatusTemp, "(%d) Auth: Fatal error accepting ClientVersion.", MyServer.ClientID[Client]);
            WriteLog(StatusTemp);

            SimpleServerSend(Client, "::Error:Fatal error accepting ClientVersion.");
            return AUTH_CMD_DISCONNECT;
        }

    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        strcpy(CI[Client].ClientVersion, FlaggedData);

        sprintf(StatusTemp, "(%d) Auth: ClientVersion: '%s'.", MyServer.ClientID[Client], CI[Client].ClientVersion);
        WriteLog(StatusTemp);

        char UpdateHTTPURL[1024 + 1];

        int CVResult = IsValidClientVersion(Client, UpdateHTTPURL);
        if(CVResult == CLIENTVER_CURRENT){
            SimpleServerSend(Client, "::Authentication.Success");
            return AUTH_CMD_SUCCESS;
        }
        else if(CVResult == CLIENTVER_SUPPORTED){
            SimpleServerSend(Client, "::Message:Client software is outdated but still supported. Update soon!");
            return AUTH_CMD_SUCCESS;
        }
        else if(CVResult == CLIENTVER_OUTDATED){
            SimpleServerSend(Client, "::Message:Client software is outdated. Update now!");
            return AUTH_CMD_DISCONNECT;
        }
        else if(CVResult == CLIENTVER_AUTOUPDATE){
            sprintf(StatusTemp, "(%d) Auth: Performing client autoupdate.", MyServer.ClientID[Client]);
            WriteLog(StatusTemp);

            sprintf(SendTemp, "::AutoUpdate:%s", UpdateHTTPURL);
            SimpleServerSend(Client, SendTemp);
            return AUTH_CMD_DISCONNECT;
        }
        else{
            sprintf(StatusTemp, "(%d) Auth: Error verifing client version.", MyServer.ClientID[Client]);
            WriteLog(StatusTemp);

            SimpleServerSend(Client, "::Error:Error verifing client version. Update now!");
            return AUTH_CMD_DISCONNECT;
        }

        sprintf(StatusTemp, "(%d) Error in AuthProcessCommand :: Logic failed in ClientVersion.", MyServer.ClientID[Client]);
        WriteLog(StatusTemp);

        SimpleServerSend(Client, "::Error:Error verifing client version. Update now!");
        return AUTH_CMD_FAILED;
    }

    sprintf(StatusTemp, "(%d) Auth: Received unknown command.", MyServer.ClientID[Client]);
    WriteLog(StatusTemp);

    return AUTH_CMD_UNKNOWN;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int AuthenticateClient(int Client)
{
    char ReceiveData[MaxReceiveSize];
    int ReceiveSize = 0;

    while(MyServer.Connected[Client])
    {
        if(MyServer.GetReceiveData(Client, ReceiveData, &ReceiveSize) )
        {
            ReceiveData[ReceiveSize] = '\0';

            int AuthCmdResult = AuthProcessCommand(Client, ReceiveData, ReceiveSize);

            if(AuthCmdResult == AUTH_CMD_FAILED)
            {
//                WriteLog("AuthCmdResult AUTH_CMD_FAILED.");
                Sleep(100);
                return AUTH_CMD_FAILED;
            }
            else if(AuthCmdResult == AUTH_CMD_UNKNOWN){
//                WriteLog("AuthCmdResult AUTH_CMD_UNKNOWN.");
                Sleep(100);
                return AUTH_CMD_UNKNOWN;
            }
            else if(AuthCmdResult == AUTH_CMD_DISCONNECT){
//                WriteLog("AuthCmdResult AUTH_CMD_SUCCESS.");
                Sleep(100);
                return AUTH_CMD_DISCONNECT;
            }
            else if(AuthCmdResult == AUTH_CMD_SUCCESS){
//                WriteLog("AuthCmdResult AUTH_CMD_SUCCESS.");
                Sleep(100);
                return AUTH_CMD_SUCCESS;
            }
            else if(AuthCmdResult == AUTH_CMD_OK){
//                WriteLog("AuthCmdResult AUTH_CMD_OK.");
                Sleep(100);
                // Still authenticating
            }
        }
        else Sleep(1);

        Sleep(1);
    }

//    WriteLog("AuthCmdResult DISCONNECTED.");
    return AUTH_CMD_DISCONNECT;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

